#include "rops_plugin.h"
#include <atlstr.h>

//This function is called when your plugin is loaded
void WINAPI Initialize(HMODULE hModule){
	//See imports.h for what these functions do/take
	*(FARPROC*)&SendPacket = GetProcAddress(hModule, "SendPacket");
	*(FARPROC*)&SendPacketEx = GetProcAddress(hModule, "SendPacketEx");
	*(FARPROC*)&RecvPacket = GetProcAddress(hModule, "RecvPacket");
	*(FARPROC*)&RecvPacketEx = GetProcAddress(hModule, "RecvPacketEx");
	*(FARPROC*)&PacketLen = GetProcAddress(hModule, "PacketLen");
	*(FARPROC*)&StrSearch = GetProcAddress(hModule, "StrSearch");
	*(FARPROC*)&StrSearchI = GetProcAddress(hModule, "StrSearchI");
	*(FARPROC*)&GetVariable =  GetProcAddress(hModule, "GetVariable");
	*(FARPROC*)&SetVariable =  GetProcAddress(hModule, "SetVariable");
	*(FARPROC*)&ParseConfig = GetProcAddress(hModule, "ParseConfig");

	//Use SetVariable here if you want to make anything available to other plugins
}

void Print(char* fmt, ...)
{
	char printMsg[512];
	int i;

	va_list vaArgs;

	va_start(vaArgs, fmt);
	_vsnprintf(printMsg, sizeof(printMsg), fmt, vaArgs);
	va_end(vaArgs);

	LPBYTE packet = (LPBYTE)malloc(sizeof(BYTE)*(lstrlen(printMsg) + 7));
	*(LPWORD)&packet[0] = 0x009A;
	*(LPWORD)&packet[2] = (WORD)(lstrlen(printMsg) + 5);
	for(i=0; i<strlen(printMsg); i++){
		*(LPBYTE)&packet[4 + i] = (BYTE)printMsg[i];
	}
	packet[4 + i] = '\0';

	RecvPacket(packet, lstrlen(printMsg) + 7);

	free(packet);
}

//After all plugins are loaded and initalized this function is called
void WINAPI LoadConfig(char* null){
	ParseConfig(&HandleMessage, "antispam.txt");

	//If your plugin relies on other plugins call GetVariable here
}

char toggleKey[512] = "ctrl+alt+t";
char blockedUsers[1024] = "";
bool antispam = true;

//HandleMessage is used for parsing the configfile and can be used for other purposes
void WINAPI HandleMessage(char* identifier, intptr_t* paramList){
	confVarList param(paramList);

	if(strcmp(identifier, "togglekey") == 0)
		strcpy(toggleKey, param.GetStr(0));
	else if(strcmp(identifier, "blockedusers") == 0)
		strcpy(blockedUsers, param.GetStr(0));
}

//When RO connects to a different server information is given here
//	There is no gurantee OnConnect will be called on map change, but it is called for account->character server->zone->character server transitions.
void WINAPI OnConnect(sockaddr_in* saddr, int saddrLen){

}

//When RO closes a socket this function is called
//	This is called prior to OnConnect most of the time, but it can also be called when RO disconnects completely.  
void WINAPI OnDisconnect(){

}

//When RO receives a packet from the server this is called
//	return false to hide the packet from RO
bool WINAPI OnRecv(char* buff, int len){
	WORD header=*(WORD*)buff;
	char *privMsgUser;
	char *user;
	if(header == 0x0097){
		if(blockedUsers == "")
			return true;
		privMsgUser = (buff + 4);
		user = strtok(blockedUsers, ",");
		while(user != NULL) {
			if(strcmp(privMsgUser, user) == 0)
				return false;
			user = strtok(NULL, ",");
		}
	}

	return true;
}

//When a plugin sends a packet to the RO client this is called
//	return false to hide the packet from RO
bool WINAPI OnRecvPlugin(char* buff, int len){
	WORD header=*(WORD*)buff;

	return true;
}

//When RO or a plugin sends a packet to the server this is called
//	return false to not send the packet to the server
bool WINAPI OnSend(char* buff, int len){
	WORD header=*(WORD*)buff;

	return true;
}

//When a key is initially pressed this is called
//	If you return false for OnKeyDown the KeyRep/KeyUp that follows will also be blocked
bool WINAPI OnKeyDown(char* keyStr){
	if (_strcmpi(keyStr, toggleKey) == 0){
		if(antispam){
			antispam = false;
			Print((char*)"   .");
		}else{
			antispam = true;
			Print((char*)"   .");
		}
		return false; //block key input
	}

	return true; //allow key input
}

//When a key is let go this is called
bool WINAPI OnKeyUp(char* keyStr){
	return true;
}

//When a key or key combination is held down this is called
//	It is advised you don't use char* keyStr for repeating keys, but instead set a char/int in keydown and check that value
void WINAPI OnKeyRep(char* keyStr){

}

//Windows call this when the dll is loaded/unloaded - use as neccesary
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID){
	switch(dwReason){
		case DLL_PROCESS_ATTACH:
			break;
		case DLL_PROCESS_DETACH:	
			break;
	}
	return true;
}